diff --git a/Makefile.am b/Makefile.am
index 6e86cd3..a3fb413 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -98,6 +98,7 @@ pam_PROGRAMS = pam_cifscreds.so
 
 pam_cifscreds.so: pam_cifscreds.c cifskey.c resolve_host.c util.c
 	$(CC) $(CFLAGS) $(AM_CFLAGS) $(LDFLAGS) -shared -fpic -o $@ $+ -lpam -lkeyutils
+man_MANS += pam_cifscreds.8
 endif
 
 SUBDIRS = contrib
diff --git a/pam_cifscreds.8 b/pam_cifscreds.8
new file mode 100644
index 0000000..e2eb9c1
--- /dev/null
+++ b/pam_cifscreds.8
@@ -0,0 +1,207 @@
+.\" Automatically generated by Pod::Man 2.27 (Pod::Simple 3.20)
+.\"
+.\" Standard preamble:
+.\" ========================================================================
+.de Sp \" Vertical space (when we can't use .PP)
+.if t .sp .5v
+.if n .sp
+..
+.de Vb \" Begin verbatim text
+.ft CW
+.nf
+.ne \\$1
+..
+.de Ve \" End verbatim text
+.ft R
+.fi
+..
+.\" Set up some character translations and predefined strings.  \*(-- will
+.\" give an unbreakable dash, \*(PI will give pi, \*(L" will give a left
+.\" double quote, and \*(R" will give a right double quote.  \*(C+ will
+.\" give a nicer C++.  Capital omega is used to do unbreakable dashes and
+.\" therefore won't be available.  \*(C` and \*(C' expand to `' in nroff,
+.\" nothing in troff, for use with C<>.
+.tr \(*W-
+.ds C+ C\v'-.1v'\h'-1p'\s-2+\h'-1p'+\s0\v'.1v'\h'-1p'
+.ie n \{\
+.    ds -- \(*W-
+.    ds PI pi
+.    if (\n(.H=4u)&(1m=24u) .ds -- \(*W\h'-12u'\(*W\h'-12u'-\" diablo 10 pitch
+.    if (\n(.H=4u)&(1m=20u) .ds -- \(*W\h'-12u'\(*W\h'-8u'-\"  diablo 12 pitch
+.    ds L" ""
+.    ds R" ""
+.    ds C` ""
+.    ds C' ""
+'br\}
+.el\{\
+.    ds -- \|\(em\|
+.    ds PI \(*p
+.    ds L" ``
+.    ds R" ''
+.    ds C`
+.    ds C'
+'br\}
+.\"
+.\" Escape single quotes in literal strings from groff's Unicode transform.
+.ie \n(.g .ds Aq \(aq
+.el       .ds Aq '
+.\"
+.\" If the F register is turned on, we'll generate index entries on stderr for
+.\" titles (.TH), headers (.SH), subsections (.SS), items (.Ip), and index
+.\" entries marked with X<> in POD.  Of course, you'll have to process the
+.\" output yourself in some meaningful fashion.
+.\"
+.\" Avoid warning from groff about undefined register 'F'.
+.de IX
+..
+.nr rF 0
+.if \n(.g .if rF .nr rF 1
+.if (\n(rF:(\n(.g==0)) \{
+.    if \nF \{
+.        de IX
+.        tm Index:\\$1\t\\n%\t"\\$2"
+..
+.        if !\nF==2 \{
+.            nr % 0
+.            nr F 2
+.        \}
+.    \}
+.\}
+.rr rF
+.\"
+.\" Accent mark definitions (@(#)ms.acc 1.5 88/02/08 SMI; from UCB 4.2).
+.\" Fear.  Run.  Save yourself.  No user-serviceable parts.
+.    \" fudge factors for nroff and troff
+.if n \{\
+.    ds #H 0
+.    ds #V .8m
+.    ds #F .3m
+.    ds #[ \f1
+.    ds #] \fP
+.\}
+.if t \{\
+.    ds #H ((1u-(\\\\n(.fu%2u))*.13m)
+.    ds #V .6m
+.    ds #F 0
+.    ds #[ \&
+.    ds #] \&
+.\}
+.    \" simple accents for nroff and troff
+.if n \{\
+.    ds ' \&
+.    ds ` \&
+.    ds ^ \&
+.    ds , \&
+.    ds ~ ~
+.    ds /
+.\}
+.if t \{\
+.    ds ' \\k:\h'-(\\n(.wu*8/10-\*(#H)'\'\h"|\\n:u"
+.    ds ` \\k:\h'-(\\n(.wu*8/10-\*(#H)'\`\h'|\\n:u'
+.    ds ^ \\k:\h'-(\\n(.wu*10/11-\*(#H)'^\h'|\\n:u'
+.    ds , \\k:\h'-(\\n(.wu*8/10)',\h'|\\n:u'
+.    ds ~ \\k:\h'-(\\n(.wu-\*(#H-.1m)'~\h'|\\n:u'
+.    ds / \\k:\h'-(\\n(.wu*8/10-\*(#H)'\z\(sl\h'|\\n:u'
+.\}
+.    \" troff and (daisy-wheel) nroff accents
+.ds : \\k:\h'-(\\n(.wu*8/10-\*(#H+.1m+\*(#F)'\v'-\*(#V'\z.\h'.2m+\*(#F'.\h'|\\n:u'\v'\*(#V'
+.ds 8 \h'\*(#H'\(*b\h'-\*(#H'
+.ds o \\k:\h'-(\\n(.wu+\w'\(de'u-\*(#H)/2u'\v'-.3n'\*(#[\z\(de\v'.3n'\h'|\\n:u'\*(#]
+.ds d- \h'\*(#H'\(pd\h'-\w'~'u'\v'-.25m'\f2\(hy\fP\v'.25m'\h'-\*(#H'
+.ds D- D\\k:\h'-\w'D'u'\v'-.11m'\z\(hy\v'.11m'\h'|\\n:u'
+.ds th \*(#[\v'.3m'\s+1I\s-1\v'-.3m'\h'-(\w'I'u*2/3)'\s-1o\s+1\*(#]
+.ds Th \*(#[\s+2I\s-2\h'-\w'I'u*3/5'\v'-.3m'o\v'.3m'\*(#]
+.ds ae a\h'-(\w'a'u*4/10)'e
+.ds Ae A\h'-(\w'A'u*4/10)'E
+.    \" corrections for vroff
+.if v .ds ~ \\k:\h'-(\\n(.wu*9/10-\*(#H)'\s-2\u~\d\s+2\h'|\\n:u'
+.if v .ds ^ \\k:\h'-(\\n(.wu*10/11-\*(#H)'\v'-.4m'^\v'.4m'\h'|\\n:u'
+.    \" for low resolution devices (crt and lpr)
+.if \n(.H>23 .if \n(.V>19 \
+\{\
+.    ds : e
+.    ds 8 ss
+.    ds o a
+.    ds d- d\h'-1'\(ga
+.    ds D- D\h'-1'\(hy
+.    ds th \o'bp'
+.    ds Th \o'LP'
+.    ds ae ae
+.    ds Ae AE
+.\}
+.rm #[ #] #H #V #F C
+.\" ========================================================================
+.\"
+.IX Title "PAM_CIFSCREDS 8"
+.TH PAM_CIFSCREDS 8 "2013-12-10" "" ""
+.\" For nroff, turn off justification.  Always turn off hyphenation; it makes
+.\" way too many mistakes in technical documents.
+.if n .ad l
+.nh
+.SH "NAME"
+pam_cifscreds \- PAM module to manage NTLM credentials in kernel keyring
+.SH "SYNOPSIS"
+.IX Header "SYNOPSIS"
+Edit the \s-1PAM\s0 configuration files for the systems that you want to 
+automatically register \s-1NTLM\s0 credentials for, e.g. /etc/pam.d/login,
+and modify as follows:
+.PP
+.Vb 5
+\&        ...
+\&        auth       substack     system\-auth
+\&    +++ auth       optional     pam_cifscreds.so
+\&        auth       include      postlogin
+\&        ...
+\&
+\&        ...
+\&        session    include      system\-auth
+\&    +++ session    optional     pam_cifscreds.so domain=DOMAIN
+\&        session    include      postlogin
+\&        ...
+.Ve
+.PP
+Change \s-1DOMAIN\s0 to the name of you Windows domain, or use host= as
+described below.
+.SH "DESCRIPTION"
+.IX Header "DESCRIPTION"
+The \fBpam_cifscreds\fR \s-1PAM\s0 module is a tool for automatically adding
+credentials (username and password) for the purpose of establishing
+sessions in multiuser mounts.
+.PP
+When a cifs filesystem is mounted with the \*(L"multiuser\*(R" option, and does
+not use krb5 authentication, it needs to be able to get the credentials
+for each user from somewhere. The \fBpam_cifscreds\fR module can be used
+to provide these credentials to the kernel automatically at login.
+.PP
+In the session section of the \s-1PAM\s0 configuration file, the module can
+either an \s-1NT\s0 domain name or a list of hostname or addresses.
+.SH "OPTIONS"
+.IX Header "OPTIONS"
+\&\fBpam_cifscreds\fR supports a couple options which can be set in the \s-1PAM\s0
+configuration files.  You must have one (and only one) of domain= or
+host=.
+.IP "\fBdebug\fR" 4
+.IX Item "debug"
+Turns on some extra debug logging.
+.IP "\fBdomain\fR=<\s-1NT\s0 domain name>" 4
+.IX Item "domain=<NT domain name>"
+Credentials will be added for the specified \s-1NT\s0 domain name.
+.IP "\fBhost\fR=<hostname or \s-1IP\s0 address>[,...]" 4
+.IX Item "host=<hostname or IP address>[,...]"
+Credentials will be added for the specified hostnames or \s-1IP\s0 addresses.
+.SH "NOTES"
+.IX Header "NOTES"
+The pam_cifscreds \s-1PAM\s0 module requires a kernel built with support for
+the \fBlogin\fR key type. That key type was added in v3.3 in mainline Linux
+kernels.
+.PP
+Since \fBpam_cifscreds\fR adds keys to the session keyring, it is highly
+recommended that one use \fBpam_keyinit\fR to ensure that a session keyring
+is established at login time.
+.SH "SEE ALSO"
+.IX Header "SEE ALSO"
+\&\fIcifscreds\fR\|(1), \fIpam_keyinit\fR\|(8)
+.SH "AUTHOR"
+.IX Header "AUTHOR"
+The pam_cifscreds \s-1PAM\s0 module was developed by Orion Poplawski
+<orion@nwra.com>.
diff --git a/pam_cifscreds.pod b/pam_cifscreds.pod
new file mode 100644
index 0000000..8c08cd6
--- /dev/null
+++ b/pam_cifscreds.pod
@@ -0,0 +1,84 @@
+# turn into a manpage with the following command:
+#
+# pod2man -s 8 -c '' -r '' --stderr pam_cifscreds.pod > pam_cifscreds.8
+#
+
+=head1 NAME
+
+pam_cifscreds - PAM module to manage NTLM credentials in kernel keyring
+
+=head1 SYNOPSIS
+
+Edit the PAM configuration files for the systems that you want to 
+automatically register NTLM credentials for, e.g. /etc/pam.d/login,
+and modify as follows:
+
+        ...
+        auth       substack     system-auth
+    +++ auth       optional     pam_cifscreds.so
+        auth       include      postlogin
+        ...
+
+        ...
+        session    include      system-auth
+    +++ session    optional     pam_cifscreds.so domain=DOMAIN
+        session    include      postlogin
+        ...
+
+Change DOMAIN to the name of you Windows domain, or use host= as
+described below.
+
+=head1 DESCRIPTION
+
+The B<pam_cifscreds> PAM module is a tool for automatically adding
+credentials (username and password) for the purpose of establishing
+sessions in multiuser mounts.
+
+When a cifs filesystem is mounted with the "multiuser" option, and does
+not use krb5 authentication, it needs to be able to get the credentials
+for each user from somewhere. The B<pam_cifscreds> module can be used
+to provide these credentials to the kernel automatically at login.
+
+In the session section of the PAM configuration file, the module can
+either an NT domain name or a list of hostname or addresses.
+
+=head1 OPTIONS
+
+B<pam_cifscreds> supports a couple options which can be set in the PAM
+configuration files.  You must have one (and only one) of domain= or
+host=.
+
+=over
+
+=item B<debug>
+
+Turns on some extra debug logging.
+
+=item B<domain>=<NT domain name>
+
+Credentials will be added for the specified NT domain name.
+
+=item B<host>=<hostname or IP address>[,...]
+
+Credentials will be added for the specified hostnames or IP addresses.
+
+=back
+
+=head1 NOTES
+
+The pam_cifscreds PAM module requires a kernel built with support for
+the B<login> key type. That key type was added in v3.3 in mainline Linux
+kernels.
+
+Since B<pam_cifscreds> adds keys to the session keyring, it is highly
+recommended that one use B<pam_keyinit> to ensure that a session keyring
+is established at login time.
+
+=head1 SEE ALSO
+
+cifscreds(1), pam_keyinit(8)
+
+=head1 AUTHOR
+
+The pam_cifscreds PAM module was developed by Orion Poplawski
+<orion@nwra.com>.